/* eslint-disable no-empty */
import { branchQueryPage } from '@/api/specialSetting'
import { getSubject, getTeacher } from '@/api/buildTeam'
import { getSchool } from '@/api/systemManage'

/**
 *
 * 为避免重复请求全局参数，将需要使用的全局参数放到vuex中缓存
 *
 * 使用:
 *
 * 按照需要直接使用 this.$store.dispatch('action', force: Bool 是否强制刷新)
 *
 * 直接从this.$store.state.name 中获取数据
 */

export default {
  state: {
    branchs: [],
    subjects: [],
    teachers: [],
    schools: [],
  },
  mutations: {
    commit_branchs: (state, branchs) => {
      state.branchs = branchs
    },
    commit_subjects: (state, subjects) => {
      state.subjects = subjects
    },
    commit_teachers: (state, teachers) => {
      state.teachers = teachers
    },
    commit_schools: (state, schools) => {
      state.schools = schools
    },
  },
  actions: {
    async setBranchs ({ commit, state }, force) {
      if (!state.branchs.length || force === true) {
        try {
          const res = await branchQueryPage({ rows: 9999 })
          commit('commit_branchs', res.data.rows)
        } catch (error) { }
      }
    },
    async setSubject ({ commit, state }, force) {
      if (!state.subjects.length || force === true) {
        try {
          const res = await getSubject({rows: 9999, tenantId: '1'})
          commit('commit_subjects', res.data)
        } catch (error) { }
      }
    },
    async setTeachers ({ commit, state }, force) {
      if (!state.subjects.length || force === true) {
        try {
          const res = await getTeacher()
          commit('commit_teachers', res.data)
        } catch (error) { }
      }
    },
    async setSchools ({ commit, state }, force) {
      if (!state.subjects.length || force === true) {
        try {
          const res = await getSchool()
          commit('commit_schools', res.data)
        } catch (error) { }
      }
    },
  }
}
